﻿using System;
using System.Collections.Generic;
using System.IO;
using Hiro.Classes;
using Hiro.Enumeracoes;
using Hiro.Estruturas_de_Dados;
using Operacoes.Classes;


namespace HiroExemploCSharp
{
    /// <summary>
    /// Classe de testes para a classe comunicação.
    ///</summary>
    public class Exemplo
    {
        #region Atributos e Propriedades
        private Comunicacao hiroDll;
        #endregion

        #region Construtores
        public Exemplo()
        {
            this.hiroDll = new Comunicacao();
            this.hiroDll.PAF_ECF_COMM = true;
        }
        #endregion

        #region Testes Métodos Públicos
        public void SetComunicacaoSerial(string nomePortaCom)
        {
            try
            {
                this.hiroDll.SetConfiguracoesNoRegistro(ETipoComunicacao.Serial,
                                                        nomePortaCom,
                                                        string.Empty,
                                                        string.Empty,
                                                        string.Empty,
                                                        string.Empty,
                                                        string.Empty,
                                                        string.Empty,
                                                        string.Empty,
                                                        string.Empty);
                this.hiroDll = new Comunicacao();
            }
            catch (Exception)
            {
                {}
                throw;
            }
        }

        public void SetComunicacaoUSB()
        {
            try
            {
                this.hiroDll.SetConfiguracoesNoRegistro(ETipoComunicacao.USB,
                                                        string.Empty,
                                                        string.Empty,
                                                        string.Empty,
                                                        string.Empty,
                                                        string.Empty,
                                                        string.Empty,
                                                        string.Empty,
                                                        string.Empty,
                                                        string.Empty);
                this.hiroDll = new Comunicacao();
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetComunicacaoTCP(string ip, string porta, string mascara, string dns, string gateway, bool dhcp)
        {
            try
            {
                this.hiroDll.SetConfiguracoesNoRegistro(ETipoComunicacao.TCPIP,
                                                        string.Empty,
                                                        string.Empty,
                                                        string.Empty,
                                                        ip,
                                                        porta,
                                                        mascara,
                                                        dns,
                                                        gateway,
                                                        dhcp ? "1" : "0");
                this.hiroDll = new Comunicacao();
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }


        public void SetNumeroSerieConcentradorTest()
        {
            try
            {
                EStatusComando status = this.hiroDll.SetNumeroSerieConcentrador("1234");
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetIDConcentradorTest()
        {
            try
            {
                EStatusComando status = this.hiroDll.SetIDConcentrador(1);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public Concentrador GetVersaoConcentradorTest()
        {
            try
            {
                return this.hiroDll.GetVersaoConcentrador();
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }
        public Bico GetStatusBico(int numBico)
        {
            try
            {
                return this.hiroDll.GetStatusBico(numBico);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }
        public String GetStatusTodosBicos()
        {
            try
            {
                return this.hiroDll.LeStatusTodosBicos();
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }
        public Abastecimento GetAbsPAFECF()
        {
            try
            {
                return this.hiroDll.GetLeituraDeAbastecimentoPAFECF();
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }
        public void SetRelogioConcentradorTest()
        {
            string strData;
            try
            {                
                strData = DateTime.Now.Year.ToString().Substring(2, 2);
                strData += DateTime.Now.Month.ToString().PadLeft(2, '0');
                strData += DateTime.Now.Day.ToString().PadLeft(2, '0');
                strData += DateTime.Now.Hour.ToString().PadLeft(2, '0');
                strData += DateTime.Now.Minute.ToString().PadLeft(2, '0');
                strData += DateTime.Now.Second.ToString().PadLeft(2, '0');
                EStatusComando status = this.hiroDll.SetRelogioConcentrador(strData);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public DateTime GetRelogioConcentradorTest()
        {
            try
            {                
                var data = this.hiroDll.GetRelogioConcentrador();
                return data;
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetConfiguracaoBicoTest()
        {
            try
            {                
                Bico bico = new Bico();
                bico.Numero = 1;
                bico.Slot = 0;
                bico.Canal = 0;
                bico.Modelo = Convert.ToChar(162);
                bico.Modo = 'A';
                bico.VirgulaPU = 3;
                bico.EnderecoLogico = 1;
                bico.PosicaoFisica = 1;
                bico.PosicaoLogica = 0;
                bico.Template = "Gilbarco_Legacy_1";
                EStatusComando status = this.hiroDll.SetConfiguracaoBico(bico);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetConfiguracaoBicoTest()
        {
            try
            {                
                Bico bico = this.hiroDll.GetConfiguracaoBico(1);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetStatusBicoTest()
        {
            try
            {                
                Bico bico = this.hiroDll.GetStatusBico(1);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetLeituraDeAbastecimentoTest()
        {
            try
            {                
                Abastecimento abastecimento = this.hiroDll.GetLeituraDeAbastecimento();
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetConfirmacaoLeituraAbastecimentoTest()
        {
            try
            {
                Operacao operador = new Operacao();                
                Abastecimento abastecimento = new Abastecimento();
                abastecimento.Endereco = "11458";
                abastecimento.EnderecoBytes = operador.LongTo4BytesRepresentation(11458);
                abastecimento = this.hiroDll.SetConfirmacaoLeituraAbastecimento(abastecimento);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetLeituraDeAbastecimentoSemApagarTest()
        {
            try
            {                
                Abastecimento actual = this.hiroDll.GetLeituraDeAbastecimentoSemApagar();
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetConfirmacaoLeituraAbastecimentoSemApagarTest()
        {
            try
            {
                Operacao operador = new Operacao();                
                Abastecimento abastecimento = new Abastecimento();
                abastecimento.Endereco = "2752";
                abastecimento.EnderecoBytes = operador.LongTo4BytesRepresentation(2752);
                abastecimento = this.hiroDll.SetConfirmacaoLeituraAbastecimentoSemApagar(abastecimento);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetPrimeiroAbastecimentoNaoApagadoParaEnvioTest()
        {
            try
            {                
                string actual = this.hiroDll.GetPrimeiroAbastecimentoNaoApagadoParaEnvio();
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetMemoriaDeAbastecimentosTest()
        {
            try
            {
                
                string enderecoAbastecimento = "0001";
                Abastecimento abastecimento = this.hiroDll.GetMemoriaDeAbastecimentos(enderecoAbastecimento);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetEncerrantesBicoTest()
        {
            try
            {                
                Bico bico = this.hiroDll.GetEncerrantesBico(1);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetPrecoDoBicoTest()
        {
            try
            {
                Bico bico = this.hiroDll.GetPrecoDoBico(1);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetPrecoBicoTest()
        {
            try
            {                
                EStatusComando status = this.hiroDll.SetPrecoBico(1, "2599");
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void DesbloquearBicoTest()
        {
            try
            {                
                EStatusComando status = this.hiroDll.DesbloquearBico(1);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void BloquearBicoTest()
        {
            try
            {                
                EStatusComando status = this.hiroDll.BloquearBico(1);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetValorAbastecimentoTest()
        {
            try
            {                
                EStatusComando status = this.hiroDll.SetValorAbastecimento(1, "5000");
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetLitrosAbastecimentoTest()
        {
            try
            {                
                EStatusComando status = this.hiroDll.SetLitrosAbastecimento(1, "20");
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetCadastroDeCartaoTest()
        {
            try
            {                
                EStatusComando status = this.hiroDll.SetCadastroDeCartao(ETipoCartao.Funcionario, "14121634");
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetCadastroDeCartaoTest()
        {
            try
            {                
                Cartao cartao = this.hiroDll.GetCadastroDeCartao("14121634", ETipoCartao.Funcionario);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetCadastroDeCartaoTest1()
        {
            try
            {                
                Cartao cartao = this.hiroDll.GetCadastroDeCartao(ETipoCartao.Funcionario, "1");
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void DeletaRegistroDeCartaoTest()
        {
            try
            {                
                EStatusComando status = this.hiroDll.DeletaRegistroDeCartao("04121634", ETipoCartao.Funcionario);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void DeletaRegistroDeCartaoTest1()
        {
            try
            {

                EStatusComando status = this.hiroDll.DeletaRegistroDeCartao(ETipoCartao.Funcionario, "1");
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void DeletaRegistroDeCArtaoTest()
        {
            try
            {

                EStatusComando status = this.hiroDll.DeletaRegistroDeCartao(ETipoCartao.Funcionario);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetConfiguracoesNoRegistroTest()
        {      
            try
            {
                bool result = this.hiroDll.SetConfiguracoesNoRegistro(ETipoComunicacao.Serial, "COM1");
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void ApagarConfiguracaoTest()
        {
            try
            {
                bool resultl = this.hiroDll.ApagarConfiguracao();
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public EStatusDaComunicacaoConcentrador TestarComunicacaoTest()
        {
            try
            {
                var status = this.hiroDll.TestarComunicacao();
                return status;
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void ApagarAbastecimentosTest()
        {
            try
            {
                bool result = this.hiroDll.ApagarAbastecimentos();
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetConfiguracaoLanTest()
        {
            try
            {
                
                SConfiguracaoTCPIP configuracao = new SConfiguracaoTCPIP();
                configuracao.EnderecoIP = "10.1.1.200";
                configuracao.Porta = "3001";
                configuracao.Gateway = "10.1.1.1";
                configuracao.DNS = "10.1.1.1";
                configuracao.Mascara = "255.255.255.0";
                configuracao.DHCP = false;
                EStatusComando statud = this.hiroDll.SetConfiguracaoLan(configuracao);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetConfiguracaoLanTest()
        {        
            try
            {
                SConfiguracaoTCPIP configuracao = this.hiroDll.GetConfiguracaoLan();
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetConfiguracaoServidorSMTPTest()
        {
            try
            {
                SConfiguracaoEmail configuracao = new SConfiguracaoEmail();
                configuracao.Endereco = "teste.teste.com.br";
                configuracao.Porta = "587";
                EStatusComando status = this.hiroDll.SetConfiguracaoServidorSMTP(configuracao);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public SConfiguracaoEmail GetConfiguracaoServidorSMTPTest()
        {
            try
            {
                SConfiguracaoEmail configuracao = new SConfiguracaoEmail();
                configuracao.Endereco = "teste.teste.com.br";
                configuracao.Porta = "587";
                configuracao = this.hiroDll.GetConfiguracaoServidorSMTP2();
                return configuracao;
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetConfiguracaoUsuarioSMTPTest()
        {
            try
            {
                SConfiguracaoEmail configuracao = new SConfiguracaoEmail();
                configuracao.Usuario = "teste@hiro.net.br";
                configuracao.Senha = "teste";
                configuracao.Autenticacao = true;
                configuracao.IdentificacaoPosto = "Teste Posto";
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetConfiguracaoUsuarioSMTPTest()
        {
            try
            {
                SConfiguracaoEmail configuracao = new SConfiguracaoEmail();
                configuracao.Usuario = "teste@hiro.net.br";
                configuracao.Senha = "teste";
                configuracao.Autenticacao = true;
                configuracao.IdentificacaoPosto = "Teste Posto";
                this.hiroDll.GetConfiguracaoServidorSMTP(ref configuracao);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetDestinatarioSMTPTest()
        {
            try
            {
                SDestinatarioSMTP destinatario = new SDestinatarioSMTP();
                destinatario.Codigo = 1;
                destinatario.Email = "teste@gmail.com";
                destinatario.Tipo = 'P';
                EStatusComando status = this.hiroDll.SetDestinatarioSMTP(destinatario);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetDestinatarioSMTPTest()
        {      
            try
            {
                SDestinatarioSMTP actual = this.hiroDll.GetDestinatarioSMTP(1, 'P');
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetTipoCombustivelTest()
        {
            try
            {
                SCombustivel combustivel = new SCombustivel();
                combustivel.Codigo = 1;
                combustivel.Descricao = "Gasolina Comum";
                EStatusComando actual = this.hiroDll.SetTipoCombustivel(combustivel);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetTipoCombustivelTest()
        {   
            try
            {
                SCombustivel combustivel = this.hiroDll.GetTipoCombustivel(1);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public Error Preset(string bico, double valor)
        {
            return this.hiroDll.Preset(bico, valor);
        }

        public void SetHorarioEnvioTotaisTest()
        {
            try
            {
                SHorarioEnvioTotais horario = new SHorarioEnvioTotais();
                horario.Codigo = 1;
                horario.Hora = 10;
                horario.Minuto = 12;
                EStatusComando status = this.hiroDll.SetHorarioEnvioTotais(horario);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetHorarioEnvioTotaisTest()
        {
            try
            {
                SHorarioEnvioTotais horario = this.hiroDll.GetHorarioEnvioTotais(1);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }        

        public void GetArquivoCartoesTest()
        {
            try
            {
                List<Cartao> result = this.hiroDll.GetArquivoCartoes(ETipoCartao.Funcionario);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void SetConfiguracaoBicoComLeitorTest()
        {
            try
            {                
                Bico bico = new Bico();
                bico.Numero = 2;
                bico.Slot = 0;
                bico.Canal = 0;
                bico.Modelo = Convert.ToChar(162);
                bico.Modo = 'A';
                bico.VirgulaPU = 3;
                bico.EnderecoLogico = 1;
                bico.PosicaoFisica = 1;
                bico.PosicaoLogica = 0;
                bico.Template = "Gilbarco_Legacy_1";
                bico.LeitorDeCartao = new LeitorDeCartao();
                bico.LeitorDeCartao.IDCPU = 1;
                bico.LeitorDeCartao.PortaCPU = 1;
                EStatusComando actual = this.hiroDll.SetConfiguracaoBicoComLeitor(bico);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        public void GetConfiguracaoBicoComLeitorTest()
        {
            try
            {                
                Bico bico = this.hiroDll.GetConfiguracaoBicoComLeitor(2);
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        /// <summary>
        /// Seta o status da gravação do firmware como iniciado.
        /// </summary>
        public void StartGravacaoFirmwareTest(string path)
        {
            try
            {
                var fileInfo = new FileInfo(path);
                var result = this.hiroDll.StartGravacaoFirmware(fileInfo.Length);
                switch (result)
                {
                    case EStatusGravacaoFirmware.ComandoProcessadoComSucesso:
                        break;
                    case EStatusGravacaoFirmware.TamanhoMaiorQueOSuportadoPelaMemoria:
                        throw new Exception("O tamanho do arquivo é maior do que o suportado pela memória. Reinicie a operação.");
                    default:
                        throw new Exception("Erro ao iniciar a gravação do novo firmware. Reinicie a operação.");
                }
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        /// <summary>
        /// Faz o envio do firmware.
        /// </summary>
        public void SendPacoteFirmwareTest(string path)
        {
            try
            {
                var index = 0;
                var buffer = new byte[200];

                this.hiroDll.AbrirComunicacaoPorta();

                using (var fsSource = File.OpenRead(path))
                {
                    var bytesToRead = (int) fsSource.Length;
                    while (bytesToRead > 0)
                    {
                        var bytesReaded = fsSource.Read(buffer, 0, 200);
                        if (bytesReaded == 0)
                        {
                            break;
                        }
                        bytesToRead -= bytesReaded;
                        var count = 0;
                        EStatusGravacaoFirmware result;
                        do
                        {
                            result = this.hiroDll.SendPacoteFirmware(buffer, index,false);
                            count++;
                        } while (result == EStatusGravacaoFirmware.PerdaDePacote && count < 4);
                        if (result != EStatusGravacaoFirmware.ComandoProcessadoComSucesso)
                        {
                            switch (result)
                            {
                                case EStatusGravacaoFirmware.PonteiroDeMemoriaNaoInicializado:
                                    throw new Exception("O ponteiro de memória não foi inicializado. Reinicie a operação.");
                                case EStatusGravacaoFirmware.MemoriaCheia:
                                    throw new Exception("A memória esta cheia. Reinicie a operação.");
                                case EStatusGravacaoFirmware.PerdaDePacote:
                                    throw new Exception("Houve perda de pacotes durante o envio. Reinicie a operação.");
                                case EStatusGravacaoFirmware.ErroDeGravacaoDeMemoria:
                                    throw new Exception("Erro ao efetuar a gravação do firmware na memória. Reinicie a operação.");
                                default:
                                    throw new Exception("Erro durante a gravação do novo firmware. Reinicie a operação.");
                            }
                        }
                        index++;
                        if (index > 255)
                        {
                            index = 0;
                        }
                    }
                }
            }
            catch (Exception)
            {
                { }
                throw;
            }
            finally
            {
                this.hiroDll.FecharComunicacaoPorta();
            }
        }

        /// <summary>
        /// Finaliza o envio do firmware.
        /// </summary>
        public void StopGravacaoFirmwareTest()
        {
            try
            {
                var result = this.hiroDll.StopGravacaoFirmware();
                switch (result)
                {
                    case EStatusGravacaoFirmware.ComandoProcessadoComSucesso:
                        break;
                    case EStatusGravacaoFirmware.NaoExisteAplicativoNovoNaMemoria:
                        throw new Exception("Não existe aplicativo novo na memória. Reinicie a operação.");
                    default:
                        throw new Exception("Erro ao encerrar a gravação do novo firmware. Reinicie a operação.");
                }
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }

        /// <summary>
        /// Manda executar o novo firmware.
        /// </summary>
        public void ExecuteFirmwareTest()
        {
            try
            {
                var sendAgain = true;
                var result = EStatusGravacaoFirmware.CalculandoCheck;
                do
                {
                    result = this.hiroDll.ExecuteFirmware();
                    if (result != EStatusGravacaoFirmware.CalculandoCheck)
                    {
                        sendAgain = false;
                    }                    
                } while (sendAgain);
                switch (result)
                {
                    case EStatusGravacaoFirmware.ComandoProcessadoComSucesso:
                        break;
                    case EStatusGravacaoFirmware.ErroDeGravacaoDeMemoria:
                        throw new Exception("Erro de gravação de memória. Reinicie a operação.");
                    case EStatusGravacaoFirmware.NaoExisteAplicativoNovoNaMemoria:
                        throw new Exception("Não existe aplicativo novo na memória. Reinicie a operação.");
                    default:
                        throw new Exception("Erro ao iniciar o novo firmware. Reinicie a operação.");
                }
            }
            catch (Exception)
            {
                { }
                throw;
            }
        }
        #endregion
    }
}
